Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision d8b47eca6f42cb0337bbfbbd1fcd114ae523a897)
+++ uspace/Makefile	(revision 663664703394632860eadef65798f751d575e737)
@@ -80,4 +80,5 @@
 	app/vlaunch \
 	app/vterm \
+	app/df \
 	srv/clipboard \
 	srv/locsrv \
Index: uspace/app/df/Makefile
===================================================================
--- uspace/app/df/Makefile	(revision 663664703394632860eadef65798f751d575e737)
+++ uspace/app/df/Makefile	(revision 663664703394632860eadef65798f751d575e737)
@@ -0,0 +1,35 @@
+#
+# Copyright (c) 2013 Manuele Conti
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+BINARY = df
+
+SOURCES = \
+	df.c 
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/df/df.c
===================================================================
--- uspace/app/df/df.c	(revision 663664703394632860eadef65798f751d575e737)
+++ uspace/app/df/df.c	(revision 663664703394632860eadef65798f751d575e737)
@@ -0,0 +1,77 @@
+/*
+ * Copyright (c) 2013 Manuele Conti
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup df
+ * @brief Df utility.
+ * @{
+ */
+/**
+ * @file
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <stats.h>
+#include <errno.h>
+#include <adt/list.h>
+#include <vfs/vfs.h>
+
+#define NAME  "df"
+
+#define HEADER_TABLE "Filesystem    512-blocks      Used      Available  Used%  Mounted on"
+
+#define PERCENTAGE(x, tot) ((long) (100L * (x) / (tot)))  
+
+int main(int argc, char *argv[])
+{
+	struct statfs st;
+
+	LIST_INITIALIZE(mtab_list);
+	get_mtab_list(&mtab_list);
+	printf("%s\n", HEADER_TABLE);
+	list_foreach(mtab_list, cur) {
+		mtab_ent_t *mtab_ent = list_get_instance(cur, mtab_ent_t,
+		    link);
+		if (statfs(mtab_ent->mp, &st) < 0)
+			return 1;
+	
+		printf("%13s %15lld %9lld %9lld %3ld%% %s\n", 
+			mtab_ent->fs_name,
+			(long long) st.f_blocks * st.f_bsize,
+			(long long) st.f_bfree * st.f_bsize,
+			(long long) (st.f_blocks - st.f_bfree) * st.f_bsize,
+			PERCENTAGE(st.f_blocks - st.f_bfree, st.f_blocks),
+			mtab_ent->mp);
+	}
+	putchar('\n');	
+	return 0;
+}
+
+/** @}
+ */
Index: uspace/lib/c/generic/vfs/vfs.c
===================================================================
--- uspace/lib/c/generic/vfs/vfs.c	(revision d8b47eca6f42cb0337bbfbbd1fcd114ae523a897)
+++ uspace/lib/c/generic/vfs/vfs.c	(revision 663664703394632860eadef65798f751d575e737)
@@ -892,4 +892,24 @@
 }
 
+int statfs(const char *path, struct statfs *buf)
+{
+	sysarg_t rc;
+	//aid_t req;
+
+	if ( NULL == buf )
+		return 1;
+
+	sysarg_t value;
+	async_exch_t *exch = vfs_exchange_begin();	
+	rc = async_req_0_1(exch, VFS_IN_STATFS, &value);
+	if (rc != EOK)
+		goto exit;
+
+	buf->f_bsize = value;
+exit:
+	vfs_exchange_end(exch);
+	return rc;
+}
+
 /** @}
  */
Index: uspace/lib/c/include/ipc/vfs.h
===================================================================
--- uspace/lib/c/include/ipc/vfs.h	(revision d8b47eca6f42cb0337bbfbbd1fcd114ae523a897)
+++ uspace/lib/c/include/ipc/vfs.h	(revision 663664703394632860eadef65798f751d575e737)
@@ -82,4 +82,5 @@
 	VFS_IN_WAIT_HANDLE,
 	VFS_IN_MTAB_GET,
+	VFS_IN_STATFS
 } vfs_in_request_t;
 
Index: uspace/lib/c/include/vfs/vfs.h
===================================================================
--- uspace/lib/c/include/vfs/vfs.h	(revision d8b47eca6f42cb0337bbfbbd1fcd114ae523a897)
+++ uspace/lib/c/include/vfs/vfs.h	(revision 663664703394632860eadef65798f751d575e737)
@@ -44,7 +44,16 @@
 #include "vfs_mtab.h"
 
+
 enum vfs_change_state_type {
 	VFS_PASS_HANDLE
 };
+
+struct statfs { 
+	short   f_type;     /* type of file system  */
+	long    f_bsize;    /* fundamental file system block size */
+	long    f_blocks;   /* total data blocks in file system */
+	long    f_bfree;    /* free blocks in fs */
+};
+
 
 extern char *absolutize(const char *, size_t *);
@@ -61,5 +70,5 @@
 extern async_exch_t *vfs_exchange_begin(void);
 extern void vfs_exchange_end(async_exch_t *);
-
+extern int statfs(const char *path, struct statfs *buf);
 #endif
 
Index: uspace/lib/fs/libfs.h
===================================================================
--- uspace/lib/fs/libfs.h	(revision d8b47eca6f42cb0337bbfbbd1fcd114ae523a897)
+++ uspace/lib/fs/libfs.h	(revision 663664703394632860eadef65798f751d575e737)
@@ -93,4 +93,5 @@
 	bool (* is_file)(fs_node_t *);
 	service_id_t (* service_get)(fs_node_t *);
+	unsigned int (* size_block)(fs_node_t *);
 } libfs_ops_t;
 
Index: uspace/srv/fs/mfs/mfs_ops.c
===================================================================
--- uspace/srv/fs/mfs/mfs_ops.c	(revision d8b47eca6f42cb0337bbfbbd1fcd114ae523a897)
+++ uspace/srv/fs/mfs/mfs_ops.c	(revision 663664703394632860eadef65798f751d575e737)
@@ -64,4 +64,5 @@
 static int mfs_check_sanity(struct mfs_sb_info *sbi);
 static bool is_power_of_two(uint32_t n);
+static unsigned int mfs_size_block(fs_node_t *fsnode);
 
 static hash_table_t open_nodes;
@@ -84,5 +85,6 @@
 	.destroy = mfs_destroy_node,
 	.has_children = mfs_has_children,
-	.lnkcnt_get = mfs_lnkcnt_get
+	.lnkcnt_get = mfs_lnkcnt_get,
+	.size_block = mfs_size_block
 };
 
@@ -1136,4 +1138,13 @@
 }
 
+static unsigned int
+mfs_size_block(fs_node_t *fsnode)
+{
+	if ( NULL == fsnode )
+		return 0;
+	/* Get block size from superblock */
+	return 512;
+}
+
 vfs_out_ops_t mfs_ops = {
 	.mounted = mfs_mounted,
Index: uspace/srv/vfs/vfs.c
===================================================================
--- uspace/srv/vfs/vfs.c	(revision d8b47eca6f42cb0337bbfbbd1fcd114ae523a897)
+++ uspace/srv/vfs/vfs.c	(revision 663664703394632860eadef65798f751d575e737)
@@ -130,4 +130,7 @@
 			vfs_get_mtab(callid, &call);
 			break;
+		case VFS_IN_STATFS:
+			vfs_statfs(callid, &call);
+			break;
 		default:
 			async_answer_0(callid, ENOTSUP);
Index: uspace/srv/vfs/vfs.h
===================================================================
--- uspace/srv/vfs/vfs.h	(revision d8b47eca6f42cb0337bbfbbd1fcd114ae523a897)
+++ uspace/srv/vfs/vfs.h	(revision 663664703394632860eadef65798f751d575e737)
@@ -222,4 +222,5 @@
 extern void vfs_wait_handle(ipc_callid_t, ipc_call_t *);
 extern void vfs_get_mtab(ipc_callid_t, ipc_call_t *);
+extern void vfs_statfs(ipc_callid_t, ipc_call_t *);
 
 #endif
Index: uspace/srv/vfs/vfs_ops.c
===================================================================
--- uspace/srv/vfs/vfs_ops.c	(revision d8b47eca6f42cb0337bbfbbd1fcd114ae523a897)
+++ uspace/srv/vfs/vfs_ops.c	(revision 663664703394632860eadef65798f751d575e737)
@@ -1418,4 +1418,13 @@
 }
 
+void vfs_statfs(ipc_callid_t rid, ipc_call_t *request)
+{
+	long long reply;
+
+	/* Get information about fs */
+	reply = 512;
+	async_answer_1(rid, EOK, reply);
+}
+
 /**
  * @}